<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfSmsInfoitem ArrayType
 * @subpackage Arrays
 */
class ArrayOfSmsInfoitem extends AbstractStructArrayBase
{
    /**
     * The SmsInfoitem
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\SmsInfoitem[]
     */
    public $SmsInfoitem;
    /**
     * Constructor method for ArrayOfSmsInfoitem
     * @uses ArrayOfSmsInfoitem::setSmsInfoitem()
     * @param \StructType\SmsInfoitem[] $smsInfoitem
     */
    public function __construct(array $smsInfoitem = array())
    {
        $this
            ->setSmsInfoitem($smsInfoitem);
    }
    /**
     * Get SmsInfoitem value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\SmsInfoitem[]|null
     */
    public function getSmsInfoitem()
    {
        return isset($this->SmsInfoitem) ? $this->SmsInfoitem : null;
    }
    /**
     * This method is responsible for validating the values passed to the setSmsInfoitem method
     * This method is willingly generated in order to preserve the one-line inline validation within the setSmsInfoitem method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateSmsInfoitemForArrayConstraintsFromSetSmsInfoitem(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfSmsInfoitemSmsInfoitemItem) {
            // validation for constraint: itemType
            if (!$arrayOfSmsInfoitemSmsInfoitemItem instanceof \StructType\SmsInfoitem) {
                $invalidValues[] = is_object($arrayOfSmsInfoitemSmsInfoitemItem) ? get_class($arrayOfSmsInfoitemSmsInfoitemItem) : sprintf('%s(%s)', gettype($arrayOfSmsInfoitemSmsInfoitemItem), var_export($arrayOfSmsInfoitemSmsInfoitemItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The SmsInfoitem property can only contain items of type \StructType\SmsInfoitem, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set SmsInfoitem value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\SmsInfoitem[] $smsInfoitem
     * @return \ArrayType\ArrayOfSmsInfoitem
     */
    public function setSmsInfoitem(array $smsInfoitem = array())
    {
        // validation for constraint: array
        if ('' !== ($smsInfoitemArrayErrorMessage = self::validateSmsInfoitemForArrayConstraintsFromSetSmsInfoitem($smsInfoitem))) {
            throw new \InvalidArgumentException($smsInfoitemArrayErrorMessage, __LINE__);
        }
        if (is_null($smsInfoitem) || (is_array($smsInfoitem) && empty($smsInfoitem))) {
            unset($this->SmsInfoitem);
        } else {
            $this->SmsInfoitem = $smsInfoitem;
        }
        return $this;
    }
    /**
     * Add item to SmsInfoitem value
     * @throws \InvalidArgumentException
     * @param \StructType\SmsInfoitem $item
     * @return \ArrayType\ArrayOfSmsInfoitem
     */
    public function addToSmsInfoitem(\StructType\SmsInfoitem $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\SmsInfoitem) {
            throw new \InvalidArgumentException(sprintf('The SmsInfoitem property can only contain items of type \StructType\SmsInfoitem, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->SmsInfoitem[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\SmsInfoitem|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\SmsInfoitem|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\SmsInfoitem|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\SmsInfoitem|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\SmsInfoitem|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string SmsInfoitem
     */
    public function getAttributeName()
    {
        return 'SmsInfoitem';
    }
}
